"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getVariablesFileMap = void 0;
const isFile = (input) => 'File' in window && input instanceof File;
const isBlob = (input) => 'Blob' in window && input instanceof Blob;
/**
 * 處理表單送出時, 將 data object 轉換成 graphql upload 格式
 * @param originVariables
 * @param parentKey
 */
const getVariablesFileMap = (originVariables) => {
    const result = { variables: {}, map: [], values: [] };
    const traverse = (obj, path) => {
        Object.entries(obj).forEach(([key, val]) => {
            const newPath = [...path, key];
            if (isFile(val) || isBlob(val)) {
                const file = val;
                result.variables[key] = null;
                result.map.push(newPath.join('.'));
                result.values.push(file);
            }
            else if (val && typeof val === 'object') {
                // 如果是Object, 往下繼續帶上層Key
                result.variables[key] = {};
                traverse(val, newPath);
            }
            else {
                result.variables[key] = val;
            }
        });
    };
    traverse(originVariables, ['variables']);
    return result;
};
exports.getVariablesFileMap = getVariablesFileMap;
//# sourceMappingURL=utils.js.map