import { OperationDefinitionNode } from 'graphql';
import { CustomFetch } from './config';
import { FetcherRenderer } from './fetcher';
import { ReactQueryVisitor } from './visitor';
export declare class CustomMapperFetcher implements FetcherRenderer {
    private visitor;
    private _mapper;
    private _isReactHook;
    constructor(visitor: ReactQueryVisitor, customFetcher: CustomFetch);
    private getFetcherFnName;
    private getSubscriptionFnName;
    generateFetcherImplementaion(): string;
    generateInfiniteQueryHook(node: OperationDefinitionNode, documentVariableName: string, operationName: string, operationResultType: string, operationVariablesTypes: string, hasRequiredVariables: boolean): string;
    generateQueryHook(node: OperationDefinitionNode, documentVariableName: string, operationName: string, operationResultType: string, operationVariablesTypes: string, hasRequiredVariables: boolean): string;
    generateMutationHook(node: OperationDefinitionNode, documentVariableName: string, operationName: string, operationResultType: string, operationVariablesTypes: string, hasRequiredVariables: boolean): string;
    generateSubscriptionHook(node: OperationDefinitionNode, documentVariableName: string, operationName: string, operationResultType: string, operationVariablesTypes: string, hasRequiredVariables: boolean): string;
}
