"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateMutationKeyMaker = exports.generateMutationKey = exports.generateQueryKeyMaker = exports.generateQueryGetKey = exports.generateQueryKey = exports.generateInfiniteQueryKeyMaker = exports.generateInfiniteQueryKey = exports.generateQueryVariablesSignature = void 0;
function generateQueryVariablesSignature(hasRequiredVariables, operationVariablesTypes) {
    return `variables${hasRequiredVariables ? '' : '?'}: ${operationVariablesTypes}`;
}
exports.generateQueryVariablesSignature = generateQueryVariablesSignature;
function generateInfiniteQueryKey(node, hasRequiredVariables) {
    if (hasRequiredVariables)
        return `['${node.name.value}.infinite', variables]`;
    return `variables === undefined ? ['${node.name.value}.infinite'] : ['${node.name.value}.infinite', variables]`;
}
exports.generateInfiniteQueryKey = generateInfiniteQueryKey;
function generateInfiniteQueryKeyMaker(node, operationName, operationVariablesTypes, hasRequiredVariables) {
    // @TODO: imagine
    const signature = generateQueryVariablesSignature(false, operationVariablesTypes);
    return `\nuseInfinite${operationName}.getKey = (${signature}) => ${generateInfiniteQueryKey(node, false)};\n`;
}
exports.generateInfiniteQueryKeyMaker = generateInfiniteQueryKeyMaker;
function generateQueryKey(node, hasRequiredVariables) {
    if (hasRequiredVariables)
        return `['${node.name.value}', args.variables]`;
    return `args?.variables ? ['${node.name.value}', args.variables]: ['${node.name.value}']`;
}
exports.generateQueryKey = generateQueryKey;
function generateQueryGetKey(node, hasRequiredVariables) {
    if (hasRequiredVariables)
        return `['${node.name.value}', variables]`;
    return `variables ? ['${node.name.value}', variables]: ['${node.name.value}']`;
}
exports.generateQueryGetKey = generateQueryGetKey;
function generateQueryKeyMaker(node, operationName, operationVariablesTypes, hasRequiredVariables) {
    // @TODO: imagine
    const signature = generateQueryVariablesSignature(false, operationVariablesTypes);
    return `\nuse${operationName}.getKey = (${signature}) => ${generateQueryGetKey(node, false)};\n`;
}
exports.generateQueryKeyMaker = generateQueryKeyMaker;
function generateMutationKey(node) {
    return `['${node.name.value}']`;
}
exports.generateMutationKey = generateMutationKey;
function generateMutationKeyMaker(node, operationName) {
    return `\nuse${operationName}.getKey = () => ${generateMutationKey(node)};\n`;
}
exports.generateMutationKeyMaker = generateMutationKeyMaker;
//# sourceMappingURL=variables-generator.js.map